﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using AIOUSBNet;  // the namespace exposes the AIOUSB Class interface 

namespace Sample1
{
    


    public partial class FormSample1 : Form
    {
        public double[] Volts = new double[128];
        public double ADC_ch0;
        public double ADC_ch1;
        public double ADC_ch2;
        public double ADC_ch3;
        public double ADC_ch4;
        public double ADC_ch5;
        public double ADC_ch6;
        public double ADC_ch7;

        public double ADC_ch8;
        public double ADC_ch9;
        public double ADC_ch10;
        public double ADC_ch11;
        public double ADC_ch12;
        public double ADC_ch13;
        public double ADC_ch14;
        public double ADC_ch15;

        public double ADC_ch16;
        public double ADC_ch17;
        public double ADC_ch18;
        public double ADC_ch19;
        public double ADC_ch20;
        public double ADC_ch21;
        public double ADC_ch22;
        public double ADC_ch23;

        public double ADC_ch24;
        public double ADC_ch25;
        public double ADC_ch26;
        public double ADC_ch27;
        public double ADC_ch28;
        public double ADC_ch29;
        public double ADC_ch30;
        public double ADC_ch31;

        private const int ERROR_SUCCESS = 0; // Win32 standard response code
        private const byte bmDifferential = 0x8; // const for Range Selection to indicate "Differential"
        private UInt32 ConfigBufSize = 21; // sizeof(Config);

        


        // One and only Device Index:
        public UInt32 DeviceIndex;
        private int NumberOfADChannelsToDisplay;

        public FormSample1()
        {
            InitializeComponent();
            labelCONSOLE_0_15.Visible = false;
            labelCONSOLE_16_31.Visible = false;
            labelHEADLINER_0_15.Visible = false;
            labelHEADLINER_16_31.Visible = false;



            // HEADLINER TEST SELECTED
            labelCONSOLE_0_15.Visible = false;
            labelCONSOLE_16_31.Visible = false;
            labelHEADLINER_0_15.Visible = true;
            labelHEADLINER_16_31.Visible = true;

            // CONSOLE TEST SELECTED
         //     labelCONSOLE_0_15.Visible=true; 
         //     labelCONSOLE_16_31.Visible=true; 
         //     labelHEADLINER_0_15.Visible=false; 
         //     labelHEADLINER_16_31.Visible=false;

            if (labelCONSOLE_0_15.Visible == true)
                {

                CH0.Text = "101 Battery Feed EOCM";
                CH1.Text = "102 Battry Feed WCM / Aux. A/V";
                CH2.Text = "103 SIB Battery Feed";
                CH3.Text = "104 Battery Feed Row 2 Heated Seat Switch";
                CH4.Text = "105 Ground";
                CH5.Text = "106 Ground";
                CH6.Text = "107 NOT USED";
                CH7.Text = "108 NOT USED";

                CH8.Text = "109 SIB Ignition";
                CH9.Text = "110 EBCM LIN (2)";
                CH10.Text = "111 PEPS Antenna (+)";
                CH11.Text = "112 PEPS Antenna (-)";
                CH12.Text = "113 AC Power Outlet Sense HI";
                CH13.Text = "114 Ground AC Outlet Only";
                CH14.Text = "115 DC to AC Inverter Control";
                CH15.Text = "116 Immobilizer Antenna (+)";

                CH16.Text = "117 Immobilizer Antenna (-)";
                CH17.Text = "118 Secondary Fused Battery (+) 23";
                CH18.Text = "119 LIN (11) Signal Rear Heated Seat Switch";
                CH19.Text = "120 Powertrain Sensor Bus Enable";
                CH20.Text = "121 Ignition Feed Console Lamp";
                CH21.Text = "122 LED Backlight Dimming Control";
                CH22.Text = "123 Battery Feed Row2 Aux. USB Power";
                CH23.Text = "124 Ground Audio Jack Only";

                CH24.Text = "125 NOT USED";
                CH25.Text = "126 NOT USED";
                CH26.Text = "127 NOT USED";
                CH27.Text = "128 12Vdc Power Outlet";
                CH28.Text = "129 5Vdc USb Type-A / RETEST Input 12V";
                CH29.Text = "130 ABORT Input 12V";
                CH30.Text = "131 FAIL Input 12V";
                CH31.Text = "132 PASS Input 12V";

            }


         
            

        }

        //  private UInt32 RedetectDevices()
        //  {
        //      AIOUSB.AIOUSB_ReloadDeviceLinks(); // redetects devices; generally just for convenience; do this first as DeviceIndices can change
        //      var di = AIOUSB.ResolveDeviceIndex(AIOUSB.diOnly);
        //      if (di == AIOUSB.diNone)
        //      {
        // handle more than one device detected, perhaps by allowing user to pick which deviceindex to use via a GetDevices() and QueryDeviceInfo() dialog


        //      }

        //      return di;

        //  }

        private UInt32 RedetectDevices()
        {
            AIOUSB.AIOUSB_ReloadDeviceLinks(); // redetects devices; generally just for convenience; do this first as DeviceIndices can change
            UInt32 di = AIOUSB.diNone;
            UInt32 diMask = AIOUSB.GetDevices();
            for (uint index = 0; index < 32; index++)
            {
                if ((diMask & (1 << (int)(index))) > 0)
                {
                    uint pPID;
                    AIOUSB.QueryDeviceInformation(index, out pPID, out _, out _, out _, out _);
                    if (pPID == 0x8159)// (8010) is USB-IIRO-16 qhile (8159) is USB-AI016-128A
                    {
                        di = index;
                        break;
                    }
                }
            }

            return di;
        }

	private void Go()
	{
            ScanTimer.Stop();

           

            DeviceIndex = RedetectDevices();
            if (DeviceIndex == AIOUSB.diNone) // diNone also means "too many"
            {
                // handle "zero devices found" and/or "more than one device found" error
                return;
            }

            AIOUSB.ADC_SetCal(DeviceIndex, ":1TO1:");

            byte ADCRangeCode = 1; // ±10V input range: change here!
            byte[] ConfigBuf = new byte[21];

            for (int i = 0; i < 16; i++)
            {
                if (DifferentialCheckBox.Checked)
                    ConfigBuf[i] = (byte)(bmDifferential | ADCRangeCode); // can be different per channel pair; 
                else
                    ConfigBuf[i] = (byte)(ADCRangeCode) // can be different per channel
                ;
            }
            ConfigBuf[16] = 0; // not calibrate mode
            ConfigBuf[17] = 5; // timer scan start

            if (DifferentialCheckBox.Checked)
            {
                ConfigBuf[18] = 0x70; // channel 0 through 7
                NumberOfADChannelsToDisplay = 8;
            }
            else
            {
                ConfigBuf[18] = 0xF0; // channel 0 through F
                NumberOfADChannelsToDisplay = 16;
            }

            ConfigBuf[19] = 0; // no oversamples

            ConfigBuf[20] = 0x10; // set end-channel top-nybble

            var status = AIOUSB.ADC_SetConfig(DeviceIndex, ConfigBuf, ref ConfigBufSize);
            if (status != ERROR_SUCCESS)
            {
                // handle error
                return;
            }

        
            ExecuteButton.Enabled = false;
            StopButton.Enabled = true;

            ScanTimer.Start();	
	}

     
        private void ExecuteButton_Click(object sender, EventArgs e)
        {
            Go();

        }

        private void ScanTimer_Tick(object sender, EventArgs e)
        {

            var status = AIOUSB.ADC_GetScanV(DeviceIndex, Volts);  // acquire scan of ADC data
            if (status != ERROR_SUCCESS)
            {
                ScanTimer.Stop();
                MessageBox.Show("ADC_GetScanV Error!");
            }
            else
            {
                ADC_ch0 = Volts[0];
                ADC_ch1 = Volts[1];
                ADC_ch2 = Volts[2];
                ADC_ch3 = Volts[3];
                ADC_ch4 = Volts[4];
                ADC_ch5 = Volts[5];
                ADC_ch6 = Volts[6];
                ADC_ch7 = Volts[7];


                if (labelHEADLINER_0_15.Visible || labelHEADLINER_16_31.Visible)
                {

                    //   if (ADC_ch0 > 5) CH0.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Ground <<< *** GND 
                    //    if (ADC_ch0 < 5) CH0.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Ground <<< *** GND 

                    //   if (ADC_ch1 > 5) CH1.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Ground <<< *** GND 
                    //   if (ADC_ch1 < 5) CH1.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Ground <<< *** GND 

                    //   if (ADC_ch2 < 5) CH2.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Overhead Console Front Camera Battery Feed <<< *** +13.8Vdc
                    //   if (ADC_ch2 > 5) CH2.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Overhead Console Front Camera Battery Feed <<< *** +13.8Vdc

                    //    if (ADC_ch3 > 5) CH3.BackColor = Color.Orange; // FAIL (____ TEST)
                    //   if (ADC_ch3 > 5) CH3.BackColor = Color.Aquamarine;  // PASS (_____ TEST)

                    //   if (ADC_ch4 > 5) CH4.BackColor = Color.Orange; // FAIL (_____ TEST)
                    //   if (ADC_ch4 > 5) CH4.BackColor = Color.Aquamarine;  // PASS (_____ TEST)

                    //   if (ADC_ch5 > 5) CH5.BackColor = Color.Orange; // FAIL (___ TEST)
                    //   if (ADC_ch5 > 5) CH5.BackColor = Color.Aquamarine;  // PASS (___ TEST)

                    //   if (ADC_ch6 > 5) CH6.BackColor = Color.Orange; // FAIL (____ TEST)
                    //   if (ADC_ch6 > 5) CH6.BackColor = Color.Aquamarine;  // PASS (____ TEST)

                    //   if (ADC_ch7 > 5) CH7.BackColor = Color.Orange; // FAIL (____ TEST)
                    //   if (ADC_ch7 > 5) CH7.BackColor = Color.Aquamarine;  // PASS (____ TEST)

                }

                ADC_ch8 = Volts[8];
                ADC_ch9 = Volts[9];
                ADC_ch10 = Volts[10];
                ADC_ch11 = Volts[11];
                ADC_ch12 = Volts[12];
                ADC_ch13 = Volts[13];
                ADC_ch14 = Volts[14];
                ADC_ch15 = Volts[15];

                if (labelCONSOLE_0_15.Visible || labelCONSOLE_16_31.Visible)
                {

                 //   if (ADC_ch8 > 5) CH8.BackColor = Color.Orange;   // FAIL (CONSOLE TEST) SIB Ignition
                 //   if (ADC_ch8 > 5) CH8.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) SIB Ignition   

                 //   if (ADC_ch9 > 5) CH9.BackColor = Color.Orange;   // FAIL (CONSOLE TEST) EBCM LIN (2)
                 //   if (ADC_ch9 > 5) CH9.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) EBCM LIN (2)

                 //   if (ADC_ch10 > 5) CH10.BackColor = Color.Orange; // FAIL (CONSOLE TEST) PEPS Antenna (+)
                 //   if (ADC_ch10 > 5) CH10.BackColor = Color.Aquamarine;  // PASS (CONSOLER TEST) PEPS Antenna (+)

                 //   if (ADC_ch11 > 5) CH11.BackColor = Color.Orange; // FAIL (CONSOLE TEST) PEPS Antenna (-)
                 //   if (ADC_ch11 > 5) CH11.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) PEPS Antenna (-)

                 //   if (ADC_ch12 > 5) CH12.BackColor = Color.Orange; // FAIL (CONSOLE TEST) AC Power Outlet Sense HI
                 //   if (ADC_ch12 > 5) CH12.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) AC Power Outlet Sense HI

                    if (ADC_ch13 < 1.9) CH13.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Ground AC Outlet Only
                    if (ADC_ch13 > 1.9) CH13.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Ground AC Outlet Only  

                 //   if (ADC_ch14 > 5) CH14.BackColor = Color.Orange; // FAIL (CONSOLE TEST) DC to AC Inverter Control
                 //   if (ADC_ch14 > 5) CH14.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) DC to AC Inverter Control

                    if (ADC_ch15 > 1.2) CH15.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Immobilizer Antenna (+)
                    if (ADC_ch15 < 1.2) CH15.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Immobilizer Antenna (+)

                }



                if (labelHEADLINER_0_15.Visible || labelHEADLINER_16_31.Visible)
                {
                    

                    //   if (ADC_ch8 > 5) CH8.BackColor = Color.Orange;   // FAIL (HEADLINER TEST) Inside Rear View Mirror - Humidity Sensor IGN Feed
                    //   if (ADC_ch8 > 5) CH8.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST)  Inside Rear View Mirror - Humidity Sensor IGN Feed 

                   //    if (ADC_ch9 > 5) CH9.BackColor = Color.Orange;   // FAIL (HEADLINER TEST) Cell Phone MIC (-)  <<<< **** GND
                   //    if (ADC_ch9 > 5) CH9.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Cell Phone MIC (-)  <<< **** GND

                    if (ADC_ch10 > 1.5) CH10.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Cell Phone MIC (+) <<< *** 5Vdc 2.2K pull up resistor
                    if (ADC_ch10 < 1.5) CH10.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Cell Phone MIC (+) <<< *** 2.2K pull up resistor

                    //   if (ADC_ch11 > 5) CH11.BackColor = Color.Orange; // FAIL (HEADLINER TEST) MIC (+) <<< *** 5Vdc 2.2K pull up resistor
                    //   if (ADC_ch11 > 5) CH11.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) MIC (+)  <<< 5Vdc 2.2K pull up resistor

                    if (ADC_ch12 < .3) CH12.BackColor = Color.Orange; // FAIL (HEADLINER TEST) MIC (-) <<< *** GND
                    if (ADC_ch12 > .3) CH12.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) MIC (-)  <<<  *** GND

                    //   if (ADC_ch13 > 5) CH13.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Center High Mounted Stop Lamp Feed
                    //   if (ADC_ch13 > 5) CH13.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Center High Mounted Stop Lamp Feed  

                    //   if (ADC_ch14 > 5) CH14.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Exterior Courtesy Lamp Feed
                    //   if (ADC_ch14 > 5) CH14.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Exterior Courtesy Lamp Feed

                    //   if (ADC_ch15 > 5) CH15.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Automatic Day Night Mirror Mirror (+)
                    //   if (ADC_ch15 > 5) CH15.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Automatic Day Night Mirror Mirror (+)

                }

                ADC_ch16 = Volts[16];
                ADC_ch17 = Volts[17];
                ADC_ch18 = Volts[18];
                ADC_ch19 = Volts[19];
                ADC_ch20 = Volts[20];
                ADC_ch21 = Volts[21];
                ADC_ch22 = Volts[22];
                ADC_ch23 = Volts[23];



                if (labelCONSOLE_0_15.Visible || labelCONSOLE_16_31.Visible)
                {

                 //  if (ADC_ch16 > 5) CH16.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Immobilizer Antenna (-)
                 //  if (ADC_ch16 > 5) CH16.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Immobilizer Antenna (-)

                 //  if (ADC_ch17 > 5) CH17.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Secondary Fused Battery (+) 23
                 //  if (ADC_ch17 > 5) CH17.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Secondary Fused Battery (+) 23 

                 //  if (ADC_ch18 > 5) CH18.BackColor = Color.Orange; // FAIL (CONSOLE TEST) LIN (11) Signal Rear Heated Seat Switch
                 //  if (ADC_ch18 > 5) CH18.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) LIN (11) Signal Rear Heated Seat Switch  

                 //  if (ADC_ch19 > 5) CH19.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Powertrain Sensor Bus Enable
                 //  if (ADC_ch19 > 5) CH19.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Powertrain Sensor Bus Enable

                   if (ADC_ch20 < 3) CH20.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Ignition Feed Console Lamp
                   if (ADC_ch20 > 3) CH20.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Ignition Feed Console Lamp

                 //  if (ADC_ch21 > 5) CH21.BackColor = Color.Orange; // FAIL (CONSOLE TEST) LED Backlight Dimming Control
                 //  if (ADC_ch21 > 5) CH21.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) LED Backlight Dimming Control 

                 //  if (ADC_ch22 > 5) CH22.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Battery Feed ROW2 / Aux. USB Power
                 //  if (ADC_ch22 > 5) CH22.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Battery Feed Row2 / Aux. USB Power

                 //  if (ADC_ch23 > 5) CH23.BackColor = Color.Orange; // FAIL (CONSOLE TEST) Ground Audio Jack Only
                 //  if (ADC_ch23 > 5) CH23.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) Ground Audio Jack Only

                }

                if (labelHEADLINER_0_15.Visible || labelHEADLINER_16_31.Visible)
                {

                 //   if (ADC_ch16 > 5) CH16.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Automatic Day Night Mirror (-)
                 //   if (ADC_ch16 > 5) CH16.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Automatic Day Night Mirror (-)

                 //   if (ADC_ch17 > 5) CH17.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Body Control Module LIN 5
                 //   if (ADC_ch17 > 5) CH17.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Body Control Module LIN 5  

                 //   if (ADC_ch18 > 5) CH18.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Upfitter Accessory 5 Feed
                 //   if (ADC_ch18 > 5) CH18.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Upfitter Accessory 5 Feed  

                 //   if (ADC_ch19 > 5) CH19.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Active Noise Canceling MIC (+)
                 //   if (ADC_ch19 > 5) CH19.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Active Noise Canceling MIC (+)

                 //   if (ADC_ch20 > 5) CH20.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Active Noise Canceling MIC (-)
                 //   if (ADC_ch20 > 5) CH20.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Active Noise Canceling MIC (-)

                 //   if (ADC_ch21 > 5) CH21.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Row 2 Dome Lamp Switch
                 //   if (ADC_ch21 > 5) CH21.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Row 2 Dome Lamp Switch 

                 //  if (ADC_ch22 > 5) CH22.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Row 2 Dome Lamp 2 Switch
                 //  if (ADC_ch22 > 5) CH22.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Row 2 Dome Lamp 2 Switch  

                    if (ADC_ch23 > 5) CH23.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Left Sunshade Interior Lamp
                    if (ADC_ch23 < 5) CH23.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Left Sunshade Interior Lamp

                }

                ADC_ch24 = Volts[24];
                ADC_ch25 = Volts[25];
                ADC_ch26 = Volts[26];
                ADC_ch27 = Volts[27];
                ADC_ch28 = Volts[28];
                ADC_ch29 = Volts[29];
                ADC_ch30 = Volts[30];
                ADC_ch31 = Volts[31];




                if (labelCONSOLE_0_15.Visible || labelCONSOLE_16_31.Visible)
                {

                 //   if (ADC_ch24 > 5) CH24.BackColor = Color.Orange; // FAIL (CONSOLE TEST) NOT USED
                 //   if (ADC_ch24 > 5) CH24.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) NOT USED

                 //   if (ADC_ch25 > 5) CH25.BackColor = Color.Orange; // FAIL (CONSOLE TEST) NOT USED
                 //   if (ADC_ch25 > 5) CH25.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) NOT USED

                 //   if (ADC_ch26 > 5) CH26.BackColor = Color.Orange; // FAIL (CONSOLE TEST) NOT USED
                 //   if (ADC_ch26 > 5) CH26.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) NOT USED  

                    if (ADC_ch27 < 2) CH27.BackColor = Color.White; // FAIL (CONSOLE TEST) 12Vdc Power Outlet
                    if (ADC_ch27 > 2) CH27.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) 12Vdc Power Outlet

                    if (ADC_ch28 < 2) CH28.BackColor = Color.White; // FAIL (CONSOLE TEST) 5Vdc USB
                    if (ADC_ch28 > 2) CH28.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST) 5Vdc USB

                 //   if (ADC_ch29 > 5) CH29.BackColor = Color.Orange; // FAIL (CONSOLE TEST)
                 //   if (ADC_ch29 > 5) CH29.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST)  

                 //   if (ADC_ch30 > 5) CH30.BackColor = Color.Orange; // FAIL (CONSOLE TEST)
                 //    if (ADC_ch30 > 5) CH30.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST)

                 //   if (ADC_ch31 > 5) CH31.BackColor = Color.Orange; // FAIL (CONSOLE TEST)
                 //   if (ADC_ch31 > 5) CH31.BackColor = Color.Aquamarine;  // PASS (CONSOLE TEST)
                }


                if (labelHEADLINER_0_15.Visible || labelHEADLINER_16_31.Visible)
                {

                    if (ADC_ch24 > 5) CH24.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Right Sunshade Interior Lamp
                    if (ADC_ch24 < 5) CH24.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Right Sunshade Interior Lamp

                 //   if (ADC_ch25 > 5) CH25.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Row 2 Dome Lamp Control
                 //   if (ADC_ch25 > 5) CH25.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Row 2 Dome Lamp Control

                    if (ADC_ch26 > 3) CH26.BackColor = Color.Orange; // FAIL (HEADLINER TEST) Row 2 Dome Lamp 2 Control
                    if (ADC_ch26 < 3) CH26.BackColor = Color.Aquamarine;  // PASS (HEADLINER TEST) Row 2 Dome Lamp 2 Control  

                    //   if (ADC_ch27 < 5) CH27.BackColor = Color.White; // FAIL (NOT USED) 
                    //   if (ADC_ch27 > 5) CH27.BackColor = Color.Aquamarine;  // PASS (NOT USED) 

                    //   if (ADC_ch28 < 5) CH28.BackColor = Color.White; // FAIL (NOT USED) 
                    //   if (ADC_ch28 > 5) CH28.BackColor = Color.Aquamarine;  // PASS (NOT USED) 

                    //   if (ADC_ch29 > 5) CH29.BackColor = Color.Orange; // FAIL (NOT USED)
                    //   if (ADC_ch29 > 5) CH29.BackColor = Color.Aquamarine;  // PASS (NOT USED)  

                    //   if (ADC_ch30 > 5) CH30.BackColor = Color.Orange; // FAIL (NOT USED)
                    //    if (ADC_ch30 > 5) CH30.BackColor = Color.Aquamarine;  // PASS (NOT USED)

                    //   if (ADC_ch31 > 5) CH31.BackColor = Color.Orange; // FAIL (NOT USED)
                    //   if (ADC_ch31 > 5) CH31.BackColor = Color.Aquamarine;  // PASS (NOT USED)




                }

                

                listBoxVoltage.Items.Clear(); 

                for (int I = 0; I < 32; ++I)  // change 32 for the number of channels your device has
                {
                    string strChVolt;
                    string formatString = "Ch {0,2:D2}: {1,8:F4}";
                    strChVolt = String.Format(formatString, I, Volts[I]);

                    listBoxVoltage.Items.Add(strChVolt); 
                }
            }
        }

        private void StopButton_Click(object sender, EventArgs e)
        {
            ScanTimer.Stop();
            ExecuteButton.Enabled = true;
            StopButton.Enabled = false;
            
        }

        private void CH0_TextChanged(object sender, EventArgs e)
        {

        }

        private void label12_Click(object sender, EventArgs e)
        {

        }

        private void label18_Click(object sender, EventArgs e)
        {

        }

        private void CH25_TextChanged(object sender, EventArgs e)
        {

        }

        private void CH17_TextChanged(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //textBoxfrm1VIN.Text = global_variables.VIN;

            if(labelHEADLINER_0_15.Visible)
            {
                labelCONSOLE_0_15.Visible = false;
            }

            this.BeginInvoke((MethodInvoker) this.Go);
            
        }

        private void label47_Click(object sender, EventArgs e)
        {

        }

        private void RFID_TextChanged(object sender, EventArgs e)
        {

        }

        private void CH29_TextChanged(object sender, EventArgs e)
        {

        }

        private void CH31_TextChanged(object sender, EventArgs e)
        {

        }

        private void CH13_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
